# Intel® nGraph™ library 

Welcome to Intel nGraph, an open source C++ library for developers of Deep 
Learning (DL) systems. Here you will find a suite of components, APIs, and 
documentation that can be used to compile and run Deep Neural Network (DNN) 
models defined in a variety of frameworks.  

The nGraph library translates a framework’s representation of computations into 
an Intermediate Representation (IR) designed to promote computational efficiency 
on target hardware. Initially-supported backends include Intel Architecture CPUs, 
the Intel® Nervana Neural Network Processor™ (NNP), and NVIDIA\* GPUs. 
Currently-supported compiler optimizations include efficient memory management 
and data layout abstraction. 

See our [install] docs for how to get started. 

For this early release, we provide [framework integration guides] to compile 
MXNet and TensorFlow-based projects.  

[install]: http://ngraph.nervanasys.com/docs/cpp/installation.html
[framework integration guides]:http://ngraph.nervanasys.com/docs/cpp/framework-integration-guides.html
